#
# Conditional build:
%bcond_without	ocaml_opt	# skip building native optimized binaries (bytecode is always built)

%ifnarch %{ix86} %{x8664} arm aarch64 ppc sparc sparcv9
%undefine	with_ocaml_opt
%endif

%define		module	biniou
Summary:	Flexible binary data format in OCaml
Summary(pl.UTF-8):	Elastyczny format danych binarnych dla OCamla
Name:		ocaml-%{module}
Version:	1.0.9
Release:	7
License:	BSD
Group:		Libraries
Source0:	http://mjambon.com/releases/biniou/%{module}-%{version}.tar.gz
# Source0-md5:	2f9f355281817912ac04c589eb463ef2
URL:		http://martin.jambon.free.fr/biniou.html
BuildRequires:	ocaml >= 3.04-7
BuildRequires:	ocaml-easy-format-devel >= 1.0.1
BuildRequires:	ocaml-findlib >= 1.4
%requires_eq	ocaml-runtime
Requires:	ocaml-easy-format >= 1.0.1
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		debug_package	%{nil}

%description
Biniou is a binary data format designed for speed, safety, ease of use
and backward compatibility as protocols evolve. Biniou is vastly
equivalent to JSON in terms of functionality but allows
implementations about 4 times as fast (see godi-yojson for
comparison), with 25-35% space savings. Biniou data can be decoded
into human-readable form without knowledge of type definitions except
for field and variant names which are represented by 31-bit hashes.

%description -l pl.UTF-8
Biniou to format danych binarnych zaprojektowany z myślą o szybkości,
bezpieczeństwie, łatwym użyciu oraz zgodności wstecznej w miarę
ewolucji protokołów. Biniou pod względem funkcjonalnym jest bliskim
odpowiednikiem formatu JSON, ale pozwala na implementacje około 4 razy
szybsze (np. godi-yojson dla porównania), z oszczędnością miejsca
rzędu 25-35%. Dane Biniou mogą być dekodowane do postaci czytelnej dla
człowieka bez znajomości definicji typów, z wyjątkiem nazw pól i
wariantów, które są reprezentowane jako 31-bitowe hasze.

%package devel
Summary:	biniou binding for OCaml - development part
Summary(pl.UTF-8):	Wiązania biniou dla OCamla - cześć programistyczna
Group:		Development/Libraries
%requires_eq	ocaml
Requires:	%{name} = %{version}-%{release}
Requires:	ocaml-easy-format-devel >= 1.0.1

%description devel
Biniou is a binary data format designed for speed, safety, ease of use
and backward compatibility as protocols evolve. Biniou is vastly
equivalent to JSON in terms of functionality but allows
implementations about 4 times as fast (see godi-yojson for
comparison), with 25-35% space savings. Biniou data can be decoded
into human-readable form without knowledge of type definitions except
for field and variant names which are represented by 31-bit hashes.

This package contains files needed to develop OCaml programs using
biniou library.

%description devel -l pl.UTF-8
Biniou to format danych binarnych zaprojektowany z myślą o szybkości,
bezpieczeństwie, łatwym użyciu oraz zgodności wstecznej w miarę
ewolucji protokołów. Biniou pod względem funkcjonalnym jest bliskim
odpowiednikiem formatu JSON, ale pozwala na implementacje około 4 razy
szybsze (np. godi-yojson dla porównania), z oszczędnością miejsca
rzędu 25-35%. Dane Biniou mogą być dekodowane do postaci czytelnej dla
człowieka bez znajomości definicji typów, z wyjątkiem nazw pól i
wariantów, które są reprezentowane jako 31-bitowe hasze.

Ten pakiet zawiera pliki niezbędne do tworzenia programów używających
biblioteki biniou.

%prep
%setup -q -n %{module}-%{version}

%build
%{__make} -j1 all %{?with_ocaml_opt:opt} \
	CC="%{__cc} %{rpmcflags} -fPIC"

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_bindir},%{_libdir}/ocaml}
%{__make} install \
	OCAMLFIND_DESTDIR=$RPM_BUILD_ROOT%{_libdir}/ocaml \
	PREFIX=$RPM_BUILD_ROOT%{_prefix} \
	DESTDIR=$RPM_BUILD_ROOT

# move to dir pld ocamlfind looks
install -d $RPM_BUILD_ROOT%{_libdir}/ocaml/site-lib/%{module}
%{__mv} $RPM_BUILD_ROOT%{_libdir}/ocaml/{,site-lib/}%{module}/META
cat <<EOF >> $RPM_BUILD_ROOT%{_libdir}/ocaml/site-lib/%{module}/META
directory="+%{module}"
EOF

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc LICENSE
%dir %{_libdir}/ocaml/%{module}
%{_libdir}/ocaml/%{module}/biniou.cma
%if %{with ocaml_opt}
%attr(755,root,root) %{_libdir}/ocaml/%{module}/biniou.cmxs
%endif
%{_libdir}/ocaml/site-lib/%{module}

%files devel
%defattr(644,root,root,755)
%{_libdir}/ocaml/%{module}/bi_*.cmi
%{_libdir}/ocaml/%{module}/bi_*.cmo
# doc?
%{_libdir}/ocaml/%{module}/bi_*.mli
%if %{with ocaml_opt}
%attr(755,root,root) %{_bindir}/bdump
%{_libdir}/ocaml/%{module}/biniou.a
%{_libdir}/ocaml/%{module}/biniou.cmxa
%{_libdir}/ocaml/%{module}/bi_*.cmx
%{_libdir}/ocaml/%{module}/bi_*.o
%endif
%changelog
* Mon Jun 05 2017 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/ocaml-biniou.git;a=log;h=auto/th/ocaml-biniou-1.0.9-7

* Mon Jun 05 2017 Jan Rękorajski <baggins@pld-linux.org> 5521799
- rebuild with ocaml 4.04.1
- release 7 (by relup.sh)

* Sat Mar 19 2016 Jan Rękorajski <baggins@pld-linux.org> be1aef3
- release 6 (by relup.sh)

* Fri Jul 24 2015 Jakub Bogusz <qboosh@pld-linux.org> 20df923
- revised packaging: .cma is dynlinkable too; release 5

* Wed Jul 22 2015 Jakub Bogusz <qboosh@pld-linux.org> cb1c089
- pl
- unified ocaml_opt bcond name, finished its support
- release 4 (ocaml rebuild)

* Sun Nov 16 2014 Jan Rękorajski <baggins@pld-linux.org> eecf669
- rebuild with ocaml 4.02
- release 3 (by relup.sh)

* Wed Feb 19 2014 Jan Rękorajski <baggins@pld-linux.org> 4426a42
- added missing deps
- rel 2

* Mon Feb 17 2014 Jan Rękorajski <baggins@pld-linux.org> 1bc94e2
- module definition moved to main package

* Mon Feb 17 2014 Jan Rękorajski <baggins@pld-linux.org> 8c6d3f7
- added main package with native plugins for dynamic loading

* Mon Feb 17 2014 Jan Rękorajski <baggins@pld-linux.org> 8950451
- up to 1.0.9

* Sun Nov 24 2013 Elan Ruusamäe <glen@delfi.ee> bd74132
- use make install, verbose files, enable opt

* Sun Nov 24 2013 Elan Ruusamäe <glen@delfi.ee> ac58557
- use macros

* Sat Nov 23 2013 Elan Ruusamäe <glen@delfi.ee> 7af1b8e
- new, version 1.0.8

